// WaitDel.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

int main(int argc, char* argv[])
{
	bool bUsage = true;

	if (argc > 3)
	{
		const char *szDirectory = argv[1];
		int iWaitSecs = atoi(argv[2]);

		if (iWaitSecs > 0)
		{
			DWORD dwWaitMillis = iWaitSecs * 1000;

			bUsage = false;

			std::set< std::string > setFilePaths;

			for (int i = 3; i < argc; ++i)
			{
				std::string strFilepath = szDirectory;
				strFilepath += '\\';
				strFilepath += argv[i];

				setFilePaths.insert( strFilepath );
			}

			DWORD dwStartTick = GetTickCount();

			HANDLE hChange = INVALID_HANDLE_VALUE;

			while (true)
			{
				if (hChange != INVALID_HANDLE_VALUE)
				{
					FindCloseChangeNotification(hChange);
					hChange = INVALID_HANDLE_VALUE;
				}

				hChange = FindFirstChangeNotification(szDirectory, TRUE, FILE_NOTIFY_CHANGE_FILE_NAME|FILE_NOTIFY_CHANGE_DIR_NAME|FILE_NOTIFY_CHANGE_ATTRIBUTES|FILE_NOTIFY_CHANGE_SIZE|FILE_NOTIFY_CHANGE_LAST_WRITE|FILE_NOTIFY_CHANGE_SECURITY);

				std::set< std::string >::iterator iterFilePath = setFilePaths.begin();

				while (iterFilePath != setFilePaths.end())
				{
					BOOL bDeleted = DeleteFile(iterFilePath->c_str());

					if (bDeleted)
					{
						iterFilePath = setFilePaths.erase( iterFilePath );
					}
					else
					{
						++iterFilePath;
					}
				}

				DWORD dwCurrentTick = GetTickCount();

				if (setFilePaths.empty()
				||	(dwCurrentTick - dwStartTick) >= dwWaitMillis
				||	hChange == INVALID_HANDLE_VALUE)
				{
					break;
				}

				DWORD dwRemainingWaitTime = dwWaitMillis - (dwCurrentTick - dwStartTick);

				if (WAIT_TIMEOUT == WaitForSingleObject(hChange, dwRemainingWaitTime))
				{
					break;
				}
			}

			if (hChange != INVALID_HANDLE_VALUE)
			{
				FindCloseChangeNotification(hChange);
				hChange = INVALID_HANDLE_VALUE;
			}

			if (!setFilePaths.empty())
			{
				printf("Gave up without deleting:\n");
				for (std::set< std::string >::const_iterator iterFilePath = setFilePaths.begin(); iterFilePath != setFilePaths.end(); ++iterFilePath)
				{
					printf("\t%s\n", iterFilePath->c_str());
				}
			}
		}
	}

	if (bUsage)
	{
		printf("Usage:\nWaitDel <directory> <wait seconds> <filename> [filename...]\n");
	}

	return 0;
}
